RDKit: RDKit::PeriodicTable Class Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
RDKit::PeriodicTable Class Reference

singleton class for retrieving information about atoms More...

`#include <PeriodicTable.h>`

## Public Member Functions
| ~PeriodicTable ()
double | getAtomicWeight (UINT atomicNumber) const
| returns the atomic weight
double | getAtomicWeight (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getAtomicWeight (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | getAtomicNumber (const char *elementSymbol) const
| returns the atomic number
int | getAtomicNumber (const std::string &elementSymbol) const
| overload
std::string | getElementSymbol (UINT atomicNumber) const
| returns the atomic symbol
std::string | getElementName (UINT atomicNumber) const
| returns the full element name
double | getRvdw (UINT atomicNumber) const
| returns the atom's van der Waals radius
double | getRvdw (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getRvdw (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getRcovalent (UINT atomicNumber) const
| returns the atom's covalent radius
double | getRcovalent (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getRcovalent (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getRb0 (UINT atomicNumber) const
| returns the atom's bond radius
double | getRb0 (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getRb0 (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | getDefaultValence (UINT atomicNumber) const
| returns the atom's default valence
int | getDefaultValence (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | getDefaultValence (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
const INT_VECT & | getValenceList (UINT atomicNumber) const
const INT_VECT & | getValenceList (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
const INT_VECT & | getValenceList (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | getNouterElecs (UINT atomicNumber) const
| returns the number of outer shell electrons
int | getNouterElecs (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | getNouterElecs (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | getMostCommonIsotope (UINT atomicNumber) const
| returns the number of the most common isotope
int | getMostCommonIsotope (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
int | getMostCommonIsotope (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getMostCommonIsotopeMass (UINT atomicNumber) const
| returns the mass of the most common isotope
double | getMostCommonIsotopeMass (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getMostCommonIsotopeMass (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getMassForIsotope (UINT atomicNumber, UINT isotope) const
double | getMassForIsotope (const std::string &elementSymbol, UINT isotope) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getMassForIsotope (const char *elementSymbol, UINT isotope) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getAbundanceForIsotope (UINT atomicNumber, UINT isotope) const
double | getAbundanceForIsotope (const std::string &elementSymbol, UINT isotope) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
double | getAbundanceForIsotope (const char *elementSymbol, UINT isotope) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | moreElectroNegative (UINT anum1, UINT anum2) const
| convenience function to determine which atom is more electronegative
UINT | getMaxAtomicNumber () const
| returns the maximum recognized atomic number
UINT | getRow (UINT atomicNumber) const
| returns the row of the periodic table
UINT | getRow (const std::string &elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
UINT | getRow (const char *elementSymbol) const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

## Static Public Member Functions
static PeriodicTable * | getTable ()
| returns a pointer to the singleton PeriodicTable

## Detailed Description

singleton class for retrieving information about atoms

Use the singleton like this:

    const PeriodicTable *tbl = PeriodicTable::getTable();
    tbl->getAtomicWeight(6); // get atomic weight for Carbon
    tbl->getAtomicWeight("C"); // get atomic weight for Carbon

Definition at line 32 of file PeriodicTable.h.

## Constructor & Destructor Documentation

## ◆ ~PeriodicTable()

RDKit::PeriodicTable::~PeriodicTable | ( |  | ) |
| inline

Definition at line 47 of file PeriodicTable.h.

## Member Function Documentation

## ◆ getAbundanceForIsotope() [1/3]

double RDKit::PeriodicTable::getAbundanceForIsotope | ( | const char * | elementSymbol,
|  | UINT | isotope ) const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 286 of file PeriodicTable.h.

References getAbundanceForIsotope().

## ◆ getAbundanceForIsotope() [2/3]

double RDKit::PeriodicTable::getAbundanceForIsotope | ( | const std::string & | elementSymbol,
|  | UINT | isotope ) const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 279 of file PeriodicTable.h.

References getAbundanceForIsotope(), and PRECONDITION.

## ◆ getAbundanceForIsotope() [3/3]

double RDKit::PeriodicTable::getAbundanceForIsotope | ( | UINT | atomicNumber,
|  | UINT | isotope ) const
| inline

returns the abundance of a particular isotope; zero if that isotope is unknown.

Definition at line 266 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getAbundanceForIsotope(), and getAbundanceForIsotope().

## ◆ getAtomicNumber() [1/2]

int RDKit::PeriodicTable::getAtomicNumber | ( | const char * | elementSymbol | ) | const
| inline

returns the atomic number

Definition at line 71 of file PeriodicTable.h.

References getAtomicNumber().

Referenced by getAtomicNumber().

## ◆ getAtomicNumber() [2/2]

int RDKit::PeriodicTable::getAtomicNumber | ( | const std::string & | elementSymbol | ) | const
| inline

overload

Definition at line 77 of file PeriodicTable.h.

References POSTCONDITION.

## ◆ getAtomicWeight() [1/3]

double RDKit::PeriodicTable::getAtomicWeight | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 66 of file PeriodicTable.h.

References getAtomicWeight().

## ◆ getAtomicWeight() [2/3]

double RDKit::PeriodicTable::getAtomicWeight | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 59 of file PeriodicTable.h.

References PRECONDITION.

## ◆ getAtomicWeight() [3/3]

double RDKit::PeriodicTable::getAtomicWeight | ( | UINT | atomicNumber | ) | const
| inline

returns the atomic weight

Definition at line 53 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getAtomicWeight().

## ◆ getDefaultValence() [1/3]

int RDKit::PeriodicTable::getDefaultValence | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 169 of file PeriodicTable.h.

References getDefaultValence().

## ◆ getDefaultValence() [2/3]

int RDKit::PeriodicTable::getDefaultValence | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 163 of file PeriodicTable.h.

References getDefaultValence(), and PRECONDITION.

## ◆ getDefaultValence() [3/3]

int RDKit::PeriodicTable::getDefaultValence | ( | UINT | atomicNumber | ) | const
| inline

returns the atom's default valence

Definition at line 158 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getDefaultValence(), and getDefaultValence().

## ◆ getElementName()

std::string RDKit::PeriodicTable::getElementName | ( | UINT | atomicNumber | ) | const
| inline

returns the full element name

Definition at line 104 of file PeriodicTable.h.

References PRECONDITION.

## ◆ getElementSymbol()

std::string RDKit::PeriodicTable::getElementSymbol | ( | UINT | atomicNumber | ) | const
| inline

returns the atomic symbol

Definition at line 98 of file PeriodicTable.h.

References PRECONDITION.

## ◆ getMassForIsotope() [1/3]

double RDKit::PeriodicTable::getMassForIsotope | ( | const char * | elementSymbol,
|  | UINT | isotope ) const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 261 of file PeriodicTable.h.

References getMassForIsotope().

## ◆ getMassForIsotope() [2/3]

double RDKit::PeriodicTable::getMassForIsotope | ( | const std::string & | elementSymbol,
|  | UINT | isotope ) const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 254 of file PeriodicTable.h.

References getMassForIsotope(), and PRECONDITION.

## ◆ getMassForIsotope() [3/3]

double RDKit::PeriodicTable::getMassForIsotope | ( | UINT | atomicNumber,
|  | UINT | isotope ) const
| inline

returns the mass of a particular isotope; zero if that isotope is unknown.

Definition at line 241 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getMassForIsotope(), and getMassForIsotope().

## ◆ getMaxAtomicNumber()

UINT RDKit::PeriodicTable::getMaxAtomicNumber | ( |  | ) | const
| inline

returns the maximum recognized atomic number

Definition at line 320 of file PeriodicTable.h.

## ◆ getMostCommonIsotope() [1/3]

int RDKit::PeriodicTable::getMostCommonIsotope | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 219 of file PeriodicTable.h.

References getMostCommonIsotope().

## ◆ getMostCommonIsotope() [2/3]

int RDKit::PeriodicTable::getMostCommonIsotope | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 213 of file PeriodicTable.h.

References getMostCommonIsotope(), and PRECONDITION.

## ◆ getMostCommonIsotope() [3/3]

int RDKit::PeriodicTable::getMostCommonIsotope | ( | UINT | atomicNumber | ) | const
| inline

returns the number of the most common isotope

Definition at line 208 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getMostCommonIsotope(), and getMostCommonIsotope().

## ◆ getMostCommonIsotopeMass() [1/3]

double RDKit::PeriodicTable::getMostCommonIsotopeMass | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 235 of file PeriodicTable.h.

References getMostCommonIsotopeMass().

## ◆ getMostCommonIsotopeMass() [2/3]

double RDKit::PeriodicTable::getMostCommonIsotopeMass | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 229 of file PeriodicTable.h.

References getMostCommonIsotopeMass(), and PRECONDITION.

## ◆ getMostCommonIsotopeMass() [3/3]

double RDKit::PeriodicTable::getMostCommonIsotopeMass | ( | UINT | atomicNumber | ) | const
| inline

returns the mass of the most common isotope

Definition at line 224 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getMostCommonIsotopeMass(), and getMostCommonIsotopeMass().

## ◆ getNouterElecs() [1/3]

int RDKit::PeriodicTable::getNouterElecs | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 203 of file PeriodicTable.h.

References getNouterElecs().

## ◆ getNouterElecs() [2/3]

int RDKit::PeriodicTable::getNouterElecs | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 197 of file PeriodicTable.h.

References getNouterElecs(), and PRECONDITION.

## ◆ getNouterElecs() [3/3]

int RDKit::PeriodicTable::getNouterElecs | ( | UINT | atomicNumber | ) | const
| inline

returns the number of outer shell electrons

Definition at line 192 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getNouterElecs(), getNouterElecs(), and moreElectroNegative().

## ◆ getRb0() [1/3]

double RDKit::PeriodicTable::getRb0 | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 153 of file PeriodicTable.h.

References getRb0().

## ◆ getRb0() [2/3]

double RDKit::PeriodicTable::getRb0 | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 147 of file PeriodicTable.h.

References getRb0(), and PRECONDITION.

## ◆ getRb0() [3/3]

double RDKit::PeriodicTable::getRb0 | ( | UINT | atomicNumber | ) | const
| inline

returns the atom's bond radius

Definition at line 142 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getRb0(), and getRb0().

## ◆ getRcovalent() [1/3]

double RDKit::PeriodicTable::getRcovalent | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 137 of file PeriodicTable.h.

References getRcovalent().

## ◆ getRcovalent() [2/3]

double RDKit::PeriodicTable::getRcovalent | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 131 of file PeriodicTable.h.

References getRcovalent(), and PRECONDITION.

## ◆ getRcovalent() [3/3]

double RDKit::PeriodicTable::getRcovalent | ( | UINT | atomicNumber | ) | const
| inline

returns the atom's covalent radius

Definition at line 126 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getRcovalent(), and getRcovalent().

## ◆ getRow() [1/3]

UINT RDKit::PeriodicTable::getRow | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 333 of file PeriodicTable.h.

References getRow().

## ◆ getRow() [2/3]

UINT RDKit::PeriodicTable::getRow | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 327 of file PeriodicTable.h.

References getRow(), and PRECONDITION.

## ◆ getRow() [3/3]

UINT RDKit::PeriodicTable::getRow | ( | UINT | atomicNumber | ) | const
| inline

returns the row of the periodic table

Definition at line 322 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getRow(), and getRow().

## ◆ getRvdw() [1/3]

double RDKit::PeriodicTable::getRvdw | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 121 of file PeriodicTable.h.

References getRvdw().

## ◆ getRvdw() [2/3]

double RDKit::PeriodicTable::getRvdw | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 115 of file PeriodicTable.h.

References getRvdw(), and PRECONDITION.

## ◆ getRvdw() [3/3]

double RDKit::PeriodicTable::getRvdw | ( | UINT | atomicNumber | ) | const
| inline

returns the atom's van der Waals radius

Definition at line 110 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getRvdw(), and getRvdw().

## ◆ getTable()

static PeriodicTable * RDKit::PeriodicTable::getTable | ( |  | ) |
| static

returns a pointer to the singleton PeriodicTable

## ◆ getValenceList() [1/3]

const INT_VECT & RDKit::PeriodicTable::getValenceList | ( | const char * | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 187 of file PeriodicTable.h.

References getValenceList().

## ◆ getValenceList() [2/3]

const INT_VECT & RDKit::PeriodicTable::getValenceList | ( | const std::string & | elementSymbol | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 181 of file PeriodicTable.h.

References getValenceList(), and PRECONDITION.

## ◆ getValenceList() [3/3]

const INT_VECT & RDKit::PeriodicTable::getValenceList | ( | UINT | atomicNumber | ) | const
| inline

returns a vector of all stable valences. For atoms where we really don't have any idea what a reasonable maximum valence is (like transition metals), the vector ends with -1

Definition at line 176 of file PeriodicTable.h.

References PRECONDITION.

Referenced by getValenceList(), and getValenceList().

## ◆ moreElectroNegative()

bool RDKit::PeriodicTable::moreElectroNegative | ( | UINT | anum1,
|  | UINT | anum2 ) const
| inline

convenience function to determine which atom is more electronegative

check if atom with atomic number `anum1` is more electronegative than the one with `anum2` this is rather lame but here is how we do it

- the atom with the higher number of outer shell electrons is considered more electronegative
- if the # of outer shell elecs are the same the atom with the lower atomic weight is more electronegative

Definition at line 302 of file PeriodicTable.h.

References getNouterElecs(), and PRECONDITION.

The documentation for this class was generated from the following file:

- PeriodicTable.h